//////////////////////////////////////////////////////////////////////////// 
// Signal_Processing_Supplementary_toolbox
//
// Copyright (c) by Y. K. Singh, CDAC, Kolkata.  2012
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////

function [xhat,nd,xhat1]=cceps(x,n)
    [%nargout,%nargin]=argn(0);
    if %nargin<2 then
        h = fft(x,-1);
    else
        h = fft(x,n);
    end
    [ah,nd] = rcunwrap(atan(imag(h),real(h)));
    logh = log(abs(h))+%i*ah;
    xhat = real(fft(logh,1));
    if %nargout==3 then
        r = roots(x);
        xx = coeff(poly(r,'x'));
        xx=real(xx($:-1:1));
        ind = find(xx~=0);
        A = mean(x(ind)./xx(ind));
    // n > 0 contributions are from zeros inside the unit circle
        a = r(find(abs(r)<=1));
        n = 1:length(x)-1;
        [a,n]=meshgrid(a,n');
        xhat1 = [log(abs(A)); -((a.^n)./n)*ones(size(a,2),1)];
    // n < 0 contributions are from zeros outside the unit circle
         b = r(find(abs(r)>1));
         //for i=1:length(b)
         //    b(i)=1/b(i);
         //end
         b=ones(b)./b;
         n = -(length(x)-1):-1;
         [b,n]=meshgrid(b,n');
         xhat1 = xhat1 + [0; ((b.^(-n))./n)*ones(size(b,2),1)];
         if size(x,1)==1 then
             xhat1 = xhat1';
         end
     end
endfunction
///////////////////////////////////////

////////////////////////////////////
function p=LocalUnwrap(p,cutoff)
    m = length(p);

// Unwrap phase angles.  Algorithm minimizes the incremental phase variation 
// by constraining it to the range [-pi,pi]
dp = diff(p,1,1);                // Incremental phase variations
dps = pmodulo(dp+%pi,2*%pi) - %pi;      // Equivalent phase variations in [-pi,pi)
dps(dps==-%pi & dp>0,:) = %pi;     // Preserve variation sign for pi vs. -pi
dp_corr = dps - dp;              // Incremental phase corrections
dp_corr(abs(dp)<cutoff,:) = 0;   // Ignore correction when incr. variation is < CUTOFF

// Integrate corrections and add to P to produce smoothed phase values
p(2:m,:) = p(2:m,:) + cumsum(dp_corr,1);

endfunction
function y=isfinite(x)
    a=isnan(x);
    b=isinf(x);
    y=~(a|b);
    y=abs(y-%f);
    
endfunction
///////////////////////////////////////////////

////////////////////////////////

//////////////////////////////////
function [y,nd]=rcunwrap(x)
    n = length(x);
    y = unwrap(x);
    nh = fix((n+1)/2);
    nd = round(y(nh+1)/%pi);
    y(:) = y(:)' - %pi*nd*(0:(n-1))/nh;
endfunction
