//////////////////////////////////////////////////////////////////////////// 
// Signal_Processing_Supplementary_toolbox
//
// Copyright (c) by Y. K. Singh, CDAC, Kolkata.  2012
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////

function [k,c]=dir2ladr(b,a)
//IIR Direct form to pole-zero Lattice-Ladder form Conversion
//  b = Numerator polynomial coefficients 
//  a = Denominator polynomial coefficients
//  K = Lattice coefficients (reflection coefficients), [K1,...,KN]
// C = Ladder Coefficients, [C0,...,CN]

a1=a(1);
a=a/a1;
b=b/a1;
M=length(b);
N=length(a);
if (M>N) then
    error("Length of 1st input <= Length of the 2nd input!");
end
b=[b,zeros(1,N-M)];
    k=zeros(1,N-1);
    A=zeros(N-1,M-1); c=b;
    for m =N-1:-1:1 
    A(m,1:m)=-a(2:m+1)*c(m+1);
    k(m)=a(m+1)
    J=a($:-1:1);
    a=(a-k(m)*J)/(1-k(m)*k(m)+%eps);
    a=a(1:m);
    dg=diag(A(m:N-1,1:N-m));
    c(m)=b(m)+ sum(diag(A(m:N-1,1:N-m)));
    end
endfunction
