//////////////////////////////////////////////////////////////////////////// 
// Signal_Processing_Supplementary_toolbox
//
// Copyright (c) by Y. K. Singh, CDAC, Kolkata.  2012
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////

function [K] = dir2latc(b)
//  FIR Direct form to All-Zero Lattice form Conversion
//  K - Lattice filter coefficients (reflection coefficients)
//  b - FIR direct form coefficients (impulse response)
//
L = length(b);
K=zeros(1,L);
if b(1) == 0 then
   error('First element must be non zero!')
elseif b(1)==b($)
   error('The first and the last element must be different');
end
K(1) =b(1); b = b/b(1);
for m=L:-1:2
K(m) = b(m);
dv=(1-K(m) *K(m));
if dv==0 then
    dv=dv+%eps;
end
b = (b(1:$-1)-K(m)*b($:-1:2)) / dv;
end
endfunction