//////////////////////////////////////////////////////////////////////////// 
// Signal_Processing_Supplementary_toolbox
//
// Copyright (c) by Y. K. Singh, CDAC, Kolkata.  2012
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////

function [b,a] = ladr2dir(K,C)
//
// Lattice-Ladder form to IIR Direct form Conversion
// K = Lattice coefficients 
// C - Ladder coefficients
// b = numerator polynomial coefficients
// a = denominator polymonial coefficients
//
N = length(K); 
M = length(C);
C = [C, zeros(1,N-M+1)] ;
J = 1; a = 1;
A = zeros(N,N);
for m=1:N
a = [a,0]+convol([0,K(m)],J);
A(m,1:m) = -a(2:m+1);
J = (a($:-1:1));
end
b(N+1) = C(N+1);
for m = N:-1:1
A(m,1:m) = A(m,1:m)*C(m+1);
b(m) = C(m) - sum(diag(A(m:N,1:N-m+1)));
end
endfunction