//////////////////////////////////////////////////////////////////////////// 
// Signal_Processing_Supplementary_toolbox
//
// Copyright (c) by Y. K. Singh, CDAC, Kolkata.  2012
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////

function y = latcfilt(K,x)
// LATTICE form realization of FIR filters
// .......................................
// y = latcfilt(K,x)
// y = output sequence
// K = LAITICE filter (reflection) coefficient array
// x = input sequence
//
Nx = length(x)-1;
x = K(1)*x;
M = length(K)-1; K = K(2:M+1);
fg = [x; [0 x(1:Nx)]];
for m = 1:M
fg = [1,K(m);K(m),1]*fg;
fg(2,:) = [0 fg(2,1:Nx)];
end
y = fg(1,:);
endfunction