//////////////////////////////////////////////////////////////////////////// 
// Signal_Processing_Supplementary_toolbox
//
// Copyright (c) by Y. K. Singh, CDAC, Kolkata.  2012
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////

function [b,nshifts]=shiftdim(x,n)
    [%nargout,%nargin]=argn(0);
    siz=size(x);
    if %nargin==1 then
        n = find(siz~=1,1)-1; // Find leading singleton dimensions
   end

if n > 0 then  // Wrapped shift to the left
  n = rem(n,ndims(x));
end 
if  isempty(n) | isequal(n,0) then
  b = x;    // Quick exit if no shift required
  nshifts = 0;
elseif (n > 0)  then
  if isequal(siz(1:n),ones(1,n)) then
    s = [siz ones(1,n+2-length(siz))]; // Leading singletons 
    b = matrix(x,s(n+1:$));
  else
    b = permute(x,[n+1:ndims(x) 1:n]);
  end
else  % Shift to the right (padding with singletons).
    b = matrix(x,[ones(1,-n),siz]);
end
nshifts = n;
endfunction