//////////////////////////////////////////////////////////////////////////// 
// Signal_Processing_Supplementary_toolbox
//
// Copyright (c) by Y. K. Singh, CDAC, Kolkata.  2012
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////

function [b,a] = stmcb( x, u_in, q, p, niter, a_in )
[out,inp]=argn(0);
if inp<3 & inp>6 then
    error('Check the number of inputs') ;
end
if length(u_in) == 1,
    if inp == 3,
        niter = 5; p = q; q = u_in;
        a_in = prony(x,0,p);
    elseif inp == 4,
        niter = p; p = q; q = u_in; 
        a_in = prony(x,0,p);
    elseif inp == 5,
        a_in = niter; niter = p; p = q; q = u_in; 
    end
    u_in = zeros(1,max(size(x)));
    u_in(1) = 1;
else
    if length(u_in)~=length(x),
        error('   X and U must have same length.')
    end
    if inp < 6
       [b,a_in] = prony(x,0,p);
    end
    if inp < 5
       niter = 5;
    end
end
a = a_in;
N = length(x);
for i=1:niter
   k = filter( 1, a, u_in );
   u = filter( 1, a, x );
   C1 = convm(u(:),p+1);
   C2 = convm(k(:),q+1);
   T = [ -C1(1:N,:) C2(1:N,:) ];
   c = T(:,2:p+q+2) \ [-T(:,1)];
   a = [1; c(1:p)];
   b = c(p+1:p+q+1);
end
a=a.';
b=b.';
endfunction
