//////////////////////////////////////////////////////////////////////////// 
// Signal_Processing_Supplementary_toolbox
//
// Copyright (c) by Y. K. Singh, CDAC, Kolkata.  2012
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////

function q=unwrap(p,cutoff,dim)
    [%nargout,%nargin]=argn(0);
    ni=%nargin;
    rflag=0;
    if ni<3 & (ndims(0)==2)&(size(p,1)==1) then
        rflag=1;
        p=p.';
    end
    nshifts = 0;
perm = 1:ndims(p);
select ni
case 1
   [p,nshifts] = shiftdim(p);
   cutoff = %pi;     // Original UNWRAP used pi*170/180.
case 2
   [p,nshifts] = shiftdim(p);
else    // nargin == 3
   perm = [dim:max(ndims(p),dim) 1:dim-1];
   p = permute(p,perm);
   if isempty(cutoff) then
      cutoff = pi; 
   end
end
   
// Reshape p to a matrix.
siz = size(p);
p = matrix(p, [siz(1) prod(siz(2:$))]);

// Unwrap each column of p
q = p;
for j=1:size(p,2)
   // Find NaN's and Inf's
   indf = find(isfinite(p(:,j)));
   // Unwrap finite data (skip non finite entries)
   q(indf,j) = LocalUnwrap(p(indf,j),cutoff);
end

// Reshape output
q = matrix(q,siz);
q = ipermute(q,perm);
q = shiftdim(q,-nshifts);
if rflag, 
   q = q.'; 
end
endfunction